HDU

来源:互联网 发布:防止刷短信验证码 php 编辑:程序博客网 时间:2024/06/16 20:16

HDU - 1078 FatMouse and Cheese

FatMouse has stored some cheese in a city. The city can be considered as a square grid of dimension n: each grid location is labelled (p,q) where 0 <= p < n and 0 <= q < n. At each grid location Fatmouse has hid between 0 and 100 blocks of cheese in a hole. Now he’s going to enjoy his favorite food.

FatMouse begins by standing at location (0,0). He eats up the cheese where he stands and then runs either horizontally or vertically to another location. The problem is that there is a super Cat named Top Killer sitting near his hole, so each time he can run at most k locations to get into the hole before being caught by Top Killer. What is worse – after eating up the cheese at one location, FatMouse gets fatter. So in order to gain enough energy for his next run, he has to run to a location which have more blocks of cheese than those that were at the current hole.

Given n, k, and the number of blocks of cheese at each grid location, compute the maximum amount of cheese FatMouse can eat before being unable to move.

Input

There are several test cases. Each test case consists of

a line containing two integers between 1 and 100: n and k
n lines, each with n numbers: the first line contains the number of blocks of cheese at locations (0,0) (0,1) … (0,n-1); the next line contains the number of blocks of cheese at locations (1,0), (1,1), … (1,n-1), and so on.
The input ends with a pair of -1’s.

Output

For each test case output in a line the single integer giving the number of blocks of cheese collected.

Sample Input

3 1
1 2 5
10 11 6
12 12 7
-1 -1

Sample Output

37
题意: 有一个n*n的网格每个网格上有奶酪,有一只每次可以走1到k步的老鼠,但是它的下一个停留点要比当前停留点的奶酪多。问最多可以得到多少奶酪。 老鼠可以向4个方向移动,且从0,0出发

分析:如果是暴搜的话 100*100的方格肯定超时的,所以想到记忆化搜索,记录从当前点出发能得到的最大奶酪数,那么dp[0][0]就是答案。
这里因为要处理k步所以只要加一个循环就可以解决了

for(int i=0;i<4;i++)    {        int aa=0;        for(int j=1;j<=k;j++)//记录走i步的落点        {            int xx=x+dir[i][0]*j;            int yy=y+dir[i][1]*j;            if(xx>=0&&xx<n&&yy>=0&&yy<n&&!vis[xx][yy]&&map[x][y]<map[xx][yy])            {                bb=max(bb,dfs(xx,yy));            }        }    }

AC代码:

#include<stdio.h>#include<string.h>#include<algorithm>using namespace std;int dp[200][200];int map[200][200];int dir[4][2]={1,0,0,1,-1,0,0,-1};int vis[200][200];int n,k;int dfs(int x,int y){    if(dp[x][y]!=0)    return dp[x][y];    int bb=dp[x][y];    for(int i=0;i<4;i++)    {        int aa=0;        for(int j=1;j<=k;j++)        {            int xx=x+dir[i][0]*j;            int yy=y+dir[i][1]*j;            if(xx>=0&&xx<n&&yy>=0&&yy<n&&!vis[xx][yy]&&map[x][y]<map[xx][yy])            {                bb=max(bb,dfs(xx,yy));            }        }    }    dp[x][y]=bb+map[x][y];    return dp[x][y];}int main(){    while(scanf("%d%d",&n,&k)==2)    {        if(n==-1&&k==-1)        break;        memset(dp,0,sizeof(dp));        for(int i=0;i<n;i++)        {            for(int j=0;j<n;j++)            scanf("%d",&map[i][j]);        }        memset(vis,0,sizeof(vis));        vis[0][0]=1;        dfs(0,0);        printf("%d\n",dp[0][0]);    }} 
0 0
原创粉丝点击